/**************************************************
opengate server test program 

Copyright (C) 2005 Opengate Project Team
Written by Yoshiaki Watanabe
Modified Katsuhiko Eguchi, 2005 

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Email: watanaby@is.saga-u.ac.jp
**************************************************/

#include	"opengatesrv.h"

/*********************/
/*  main routine     */
/*********************/
int  main(int argc, char **argv)
{
  char clientAddr4[100]="127.0.0.1";
  char clientAddr6[100]="::1";
  char userID[100]="user1";
  char extraID[100]="default";
  char dummy[100];
  int duration=60; 
  struct clientAddr ClientAddr;
  struct clientAddr *pClientAddr;
  pClientAddr = &ClientAddr;
  strncpy(ClientAddr.ipAddr,"127.0.0.1",ADDRMAXLN);
  ClientAddr.next=NULL;
  strncpy(ClientAddr.ruleNumber,"10000",WORDMAXLN);
  ClientAddr.ipType=IPV4;
  ClientAddr.timeIn=time(NULL);


  /* prepare config file */
  OpenConfFile();
 
  /* start log */
  errToSyslog(atoi(GetConfValue("Syslog/Enable")));
  openlog(argv[0], LOG_PID, atoi(GetConfValue("Syslog/Facility")));

  /* init config */
  InitConf();

  SetupConfExtra(userID,extraID);

  printf("Config file=[%s]\n",CONFIGFILE);
  printf("UserID=[%s]\n",userID);
  printf("ExtraID=[%s]\n",extraID);

  /* guide for connecting */
  printf("Waiting connection for %d seconds\n",duration);
  printf("\n");
  printf("Try to connect from other window as\n");
  printf("> telnet %s %d\n", clientAddr4, GetListenPort());
  printf("> %s\n",userID);
  printf("\n");
  printf("When %s seconds passed, hello is received\n",
	 GetConfValue("ActiveCheck/Interval"));
  printf("Reply the message as\n");
  printf("> hello\n");
  printf("\n");
  printf("To close connection, Enter as\n");
  printf("> quit\n");
  printf("\n");

  /* connection wait */
  WaitAppletConnect(userID, clientAddr4,clientAddr6, duration, "",4,pClientAddr);
  
  printf("Connected (or timeout)\n");
  printf("Wait closing\n");
  
  /* close wait */
  WaitClientClose(pClientAddr,"user",NULL,NULL,4);

  printf("Connection closed\n");

  return 0;
}
